<?php
/**
 * @copyright   Copyright (C) 2005 - 2017 Michael Richey. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
defined('_JEXEC') or die;
if(!class_exists('SubformTwitterCard',false)) {
	class SubformTwitterCard {
		private $card;
		private $siteaccount;
		private $creatoraccount;
		private $title;
		private $description;
		private $image;
		private $large_image;
		private $imagealt;
		private $player;
		private $player_width;
		private $player_height;
		private $player_stream;
		private $player_stream_content_type;
		private $app_country;
		private $app_name_iphone;
		private $app_id_iphone;
		private $app_url_iphone;
		private $app_name_ipad;
		private $app_id_ipad;
		private $app_url_ipad;
		private $app_name_googleplay;
		private $app_id_googleplay;
		private $app_url_googleplay;

		public function __construct($json) {
			foreach((array)json_decode($json) as $key=>$value) {
				$this->{$key} = $value?:false;
			}
			if(!isset($this->card)) {
				return;
			}
			$this->doc = JFactory::getDocument();
			$method = '_'.$this->card;
			$this->{$method}();
		}
		
		public function _summary() {
			$this->doc->setMetaData('twitter:card','summary');
			if(strlen($this->siteaccount)) {
				$this->doc->setMetaData('twitter:site',$this->siteaccount);
			}
			$this->doc->setMetaData('twitter:title',$this->title);
			if(strlen($this->description)) {
				$this->doc->setMetaData('twitter:description',$this->description);
			}
			if(strlen($this->image)) {
				$this->doc->setMetaData('twitter:image',JURI::root(false).$this->image);
			}
			if(strlen($this->imagealt)) {
				$this->doc->setMetaData('twitter:image:alt',$this->imagealt);
			}
		}
		
		public function _summary_large_image() {
			$this->doc->setMetaData('twitter:card','summary_large_image');
			if(strlen($this->siteaccount)) {
				$this->doc->setMetaData('twitter:site',$this->siteaccount);
			}
			$this->doc->setMetaData('twitter:title',$this->title);
			if(strlen($this->description)) {
				$this->doc->setMetaData('twitter:description',$this->description);
			}
			if(strlen($this->image)) {
				$this->doc->setMetaData('twitter:image',JURI::root(false).$this->large_image);
			}
			if(strlen($this->imagealt)) {
				$this->doc->setMetaData('twitter:image:alt',$this->imagealt);
			}			
		}
		
		public function _app() {
			$this->doc->setMetaData('twitter:card','app');
			$this->doc->setMetaData('twitter:site',$this->siteaccount);
			if(strlen($this->description)) {
				$this->doc->setMetaData('twitter:description',$this->description);
			}
			$this->doc->setMetaData('twitter:app:id:iphone',$this->app_id_iphone);
			$this->doc->setMetaData('twitter:app:id:ipad',$this->app_id_ipad);
			$this->doc->setMetaData('twitter:app:id:googleplay',$this->app_name_googleplay);
			if(strlen($this->app_url_iphone)) {
				$this->doc->setMetaData('twitter:app:url:iphone',$this->app_url_iphone);
			}
			if(strlen($this->app_url_ipad)) {
				$this->doc->setMetaData('twitter:app:url:ipad',$this->app_url_ipad);
			}
			if(strlen($this->app_country)) {
				$this->doc->setMetaData('twitter:app:country',$this->app_country);
			}
			if(strlen($this->app_url_googleplay)) {
				$this->doc->setMetaData('twitter:app:url:googleplay',$this->app_url_googleplay);
			}
		}
		
		public function _player() {
			$this->doc->setMetaData('twitter:card','player');			
			$this->doc->setMetaData('twitter:title',$this->title);
			$this->doc->setMetaData('twitter:site',$this->siteaccount);
			if(strlen($this->description)) {
				$this->doc->setMetaData('twitter:description',$this->description);
			}
			$this->doc->setMetaData('twitter:player',$this->player);
			$this->doc->setMetaData('twitter:player:width',$this->player_width);
			$this->doc->setMetaData('twitter:player:height',$this->player_height);
			$this->doc->setMetaData('twitter:image',JURI::root(false).$this->image);
			if(strlen($this->imagealt)) {
				$this->doc->setMetaData('twitter:image:alt',$this->imagealt);
			}		
		}
	}	
}
new SubformTwitterCard($value);